/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_GENETIC_ALGORITHM_H
#define		Q_GENETIC_ALGORITHM_H

#include "qevolutionaryalgorithm.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QGeneticAlgorithm class
//
// Class that implements genetic algorithm
//
///////////////////////////////////////////////////////////

class QGeneticAlgorithm : public QEvolutionaryAlgorithm {
protected:

	QGeneticAlgorithm (const QGeneticAlgorithm& argEA);
	virtual QGeneticAlgorithm& operator= (const QGeneticAlgorithm& argEA);

public:
	QGeneticAlgorithm (void);
	virtual ~QGeneticAlgorithm (void);

	// int setParameters (const QGAParameters& argParams)
	//	Sets parameters of the EA and makes necessary initializations
	//	Returns Q_OK on success
	virtual int setParameters (const QEAParameters& argParams);

	// int run ()
	//	Performs the main routine of evolutionary algorithm/model
	//	Returns Q_OK on success
	virtual int run ();

	// QEvolutionaryAlgorithm* clone ()
	//	Makes copy of the existing object
	virtual QEvolutionaryAlgorithm* clone ();

	// int printResults (__VECTOR_RUN_SUMMARY& argS, ostream& out)
	//	Prints algorithm specific results into the passed output stream
	virtual int printResults (__VECTOR_RUN_SUMMARY& argS, ostream& out);

	// int printName (ostream& out)
	//	Prints algorithm name into the specified output stream
	virtual int printName (ostream& out);
};

};

#endif

