/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_DISTANCE_H
#define		Q_DISTANCE_H

#include "qindividual.h"

namespace ECWorkshop {

///////////////////////////////////////////////
//
//	QDistance class
//
// Class for distance measure between two individuals
//
///////////////////////////////////////////////
class QDistance {
protected:
	double measureHamming (QIndividual*, QIndividual*);
	double measureEuclidean (QIndividual*, QIndividual*);

public:
	QDistance ();
	~QDistance ();

	virtual double measure (QIndividual*, QIndividual*);
};

//
/////////////////////////////////////////////////
////
////	QHammingDistance class
////
//// Hamming distance measure for [integer] and [string] encoding
////
/////////////////////////////////////////////////
//class QHammingDistance : public QDistance {
//public:
//	QHammingDistance ();
//	~QHammingDistance ();
//
//	virtual double measure (QIndividual*, QIndividual*);
//};
//
/////////////////////////////////////////////////
////
////	QEuclideanDistance class
////
//// Euclidean distance measure for [real] encoding
////
/////////////////////////////////////////////////
//class QEuclideanDistance : public QDistance {
//public:
//	QEuclideanDistance ();
//	~QEuclideanDistance ();
//
//	virtual double measure (QIndividual*, QIndividual*);
//};

};

#endif

