/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		QGENE_H
#define		QGENE_H

#include "../include/qec.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QGene class
//
///////////////////////////////////////////////////////////

class QGene {
public:
	QGene (void);
	QGene (const QGene& argGene);
	virtual ~QGene (void);

	virtual QGene& operator= (const QGene& argGene);

	virtual QGene* clone () const = 0;
	virtual QEncodingType getEncodingType () const = 0;
	virtual bool equalsTo (const QGene* argGene) const = 0;
	virtual int assign (const QGene* argGene) = 0;
};

typedef		vector<QGene*>			__VECTOR_GENE_PTR;

};	// namespace

#endif
