/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#include "qrcpopulation.h"
#include "qrcindividual.h"

using namespace ECWorkshop;

int QRCPopulation::createPopulation (const int argSize) {
	if ((int)_inds.size () > 0) {
		clearPopulation ();
	}

	int i;

	for (i=0; i<argSize; i++) {
		_inds.push_back (new QRCIndividual());
	}

	return Q_OK;
}

QRCPopulation::QRCPopulation (void) {
}

QRCPopulation::QRCPopulation (const QRCPopulation& argPopul)
: QPopulation(argPopul) {
}

QRCPopulation::~QRCPopulation (void) {
}

QRCPopulation& QRCPopulation::operator= (const QRCPopulation& argPopul) {
	QPopulation::operator = (argPopul);
	return (*this);
}

QEncodingType QRCPopulation::getEncodingType () const {
	return QET_REAL;
}

QPopulation* QRCPopulation::clone () const {
	return new QRCPopulation (*this);
}

int QRCPopulation::addIndividual () {
	QRCIndividual tempInd;
	tempInd.setParameters (_params);
	_inds.push_back (tempInd.clone ());
	return (int)_inds.size();
}

