/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_STRING_GENE_H
#define		Q_STRING_GENE_H

#include "../include/qec.h"

#include "qgene.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QStringGene class
//
///////////////////////////////////////////////////////////

class QStringGene : public QGene {
protected:

	unsigned int _value;

public:
	QStringGene (void);
	QStringGene (const QStringGene& argGene);
	virtual ~QStringGene (void);

	virtual QStringGene& operator= (const QStringGene& argGene);

	virtual QGene* clone () const;
	virtual QEncodingType getEncodingType () const;
	virtual bool equalsTo (const QGene* argGene) const;
	virtual int assign (const QGene* argGene);

	virtual unsigned int getValue () const;
	virtual int setValue (const unsigned int argValue);
};

typedef		vector<QStringGene>		__VECTOR_STRING_GENE;

};	// namespace

#endif
