/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_RUNSUMMARY_H
#define		Q_RUNSUMMARY_H

#include <time.h>
#include "../../qtools/qtools.h"

namespace ECWorkshop {

	class QIndividual;

//
// Stores data which is collected during single run of EA
//

struct QRunSummary {
//	Data to store information about the progress of EA's run

	int generation;
	int feCount;

//	Data to collect information about EA run

	__VECTOR_DOUBLE means, devs;	// Contain values for errors means and deviations for each generation
	__VECTOR_DOUBLE bests, worsts;	// Contain values for the best and the worst individuals for each generation
	__VECTOR_DOUBLE popSizes;	// Contains values of population size in different generations
	clock_t startClock, finishClock, firstHitClock;	// 
	double time, firstHitTime;	// time (in seconds) required for single run and to obtain a solution respectively
	int firstHitFECount;
	int firstHitGeneration;
	int convergenceGeneration;
	QIndividual* currentBest;
	QIndividual* firstHitSolution;	// first found solution

	QRunSummary ();
	QRunSummary (const QRunSummary& argSummary);
	~QRunSummary ();

	QRunSummary& operator= (const QRunSummary& argSummary);

	int reset ();
};

typedef		vector<QRunSummary>		__VECTOR_RUN_SUMMARY;

};

#endif
