/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_MUTATION_OPERATOR_H
#define		Q_MUTATION_OPERATOR_H

#include "../qoperator.h"

#include "../../encodings/qindividual.h"

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//		QMutationOperator class
//
///////////////////////////////////////////////////////////

class QMutationOperator : public QOperator {
protected:

	QIndividual *_mutant;

	QMutationOperator (void);

public:

	QMutationOperator (const QEvolutionaryAlgorithm* owner);
	QMutationOperator (const QMutationOperator& argMut);
	virtual ~QMutationOperator (void);

	virtual QMutationOperator& operator= (const QMutationOperator& argMut);

	// int setMutant (QIndividual* argMut)
	// Sets individual over which the mutation is performed
	virtual int setMutant (QIndividual* argMut);

	virtual QEncodingType getEncodingType () const = 0;
	virtual QMutationOperator* clone () const = 0;

};

typedef vector<QMutationOperator*>	__VECTOR_MUTATION_PTR;

};

#endif
