/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

#ifndef		Q_NICHING_OPERATOR
#define		Q_NICHING_OPERATOR

#include "../qoperator.h"

#include "../../encodings/include.h"

namespace ECWorkshop {

class QNichingOperator : public QOperator {
protected:
	QPopulation* _popul;

	// int assignNiches ()
	// Assignes niches to individuals of the [_popul] population
	virtual int assignNiches (__TABLE_DOUBLE& mdist);

	// int calculateDistanceMatrix ()
	// Calculates matrix of distances for the [_popul] population
	// and writes results into the given matrix
	virtual int calculateDistanceMatrix (__TABLE_DOUBLE& dist);

	QNichingOperator ();

public:
	QNichingOperator (const QEvolutionaryAlgorithm* owner);
	QNichingOperator (const QNichingOperator& argNiching);
	virtual ~QNichingOperator ();

	virtual QNichingOperator& operator= (const QNichingOperator& argNiching);

	virtual int setPopulation (QPopulation* argPopul);

	virtual QNichingOperator* clone () = 0;
};

typedef	vector<QNichingOperator*>	__VECTOR_NICHING_PTR;

};

#endif

