/*****************************************

ECWorkshop -- evolutionary computation
toolkit library

Web: http://qai.narod.ru/ecw/
Mailto: qai@mail.ru

Copyright (C) 2007 by Yury Tsoy


This program is free software; you can
redistribute it and/or modify it under the
terms of the GNU General Public License as
published by the Free Software Foundation;
either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that
it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE. See the GNU General Public License
for more details.

You should have received a copy of the GNU
General Public License along with this
program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330,
Boston, MA  02111-1307  USA

*/

//#include "include.h"

#include "qproblem.h"

#ifndef	Q_ANN_PROBLEM_H
#define	Q_ANN_PROBLEM_H

namespace ECWorkshop {

///////////////////////////////////////////////////////////
//
//	Base class for ANN (and similar approaches) related problems
//
///////////////////////////////////////////////////////////

class QANNProblem : public QProblem {
protected:
	__TABLE_DOUBLE _inputs, _outputs;	// training data
	int _inputsNumber, _outputsNumber;

public:
	QANNProblem (void);
	virtual ~QANNProblem (void);

	// Returns number of input signals
	virtual int getInputsNumber ();

	// Returns number of output signals
	virtual int getOutputsNumber ();

//	virtual int testIndividual (QIndividual*) const = 0;
};

};

#endif
